
[Setting category="CPCounter" name="Show CP counter"]
bool showCounter = true;

[Setting category="CPCounter" name="Position" min=0 max=1]
#if MP4
vec2 showCounterPosition = vec2(0.5, 0.906);
#else
// tmnext position
vec2 showCounterPosition = vec2(0.5, 0.938);
#endif

[Setting category="CPCounter" name="CP counter size"]
uint showCounterSize = 24;

#if MP4
enum LapOptions {
    Never,
    IfMultilap,
    Always
}

[Setting category="CPCounter" name="Include lap count"]
LapOptions showCounterLaps = LapOptions::IfMultilap;

[Setting category="CPCounter" name="Show current lap instead of completed laps"]
bool add1ToLapCount = false;
#endif

uint CPcount = 0;
uint takenCPcount = 0;
uint currentLap = 0;

// renders a checkpoint counter using its already tracked CP data
void RenderCPCounter() {

    nvg::FontSize(showCounterSize);
    nvg::FontFace(font);
    string text = '' + takenCPcount + ' / ' + CPcount;
    // can't easily detect lap count in next
#if MP4
    // rootmap is checked before calling this
    if (showCounterLaps == LapOptions::Always) {
        CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);
        if (rootMap.TMObjective_IsLapRace) {
            if (add1ToLapCount) {
                text += ' : ' + (currentLap + 1) + ' / ' + rootMap.TMObjective_NbLaps;
            } else {
                text += ' : ' + currentLap + ' / ' + rootMap.TMObjective_NbLaps;
            }
        } else {
            if (add1ToLapCount) {
                text += ' : 1 / 0';
            } else {
                text += ' : 0 / 0';
            }
        }
    } else if (showCounterLaps == LapOptions::IfMultilap) {
        CGameCtnChallenge@ rootMap = cast<CGameCtnChallenge>(GetApp().RootMap);
        if (rootMap.TMObjective_IsLapRace) {
            if (add1ToLapCount) {
                text += ' : ' + (currentLap + 1) + ' / ' + rootMap.TMObjective_NbLaps;
            } else {
                text += ' : ' + currentLap + ' / ' + rootMap.TMObjective_NbLaps;
            }
        }
    }
#endif

    vec2 textSize = nvg::TextBounds(text);
    vec2 pos = vec2(showCounterPosition.x * (Draw::GetWidth() - textSize.x), showCounterPosition.y * (Draw::GetHeight() - textSize.y));
    
    // drop shadow
    nvg::FillColor(vec4(0.f, 0.f, 0.f, 1.f));
    nvg::Text(pos.x+2,pos.y+2, text);
    nvg::FillColor(vec4(1.f, 1.f, 1.f, 1.f));

    nvg::Text(pos.x,pos.y, text);
}